$(document).ready(function() {
	var currTab = { button: "#nav_cli a",
					content: "#cli" };

	$("#nav_cli").click(function () {
		if(currTab.content == "#cli")
			return;
		$(currTab.button).removeClass("selected");
		$("#nav_cli a").addClass("selected");
		$(currTab.content).fadeOut("50", function() { $("#cli").fadeIn("250"); });
		currTab = { button: "#nav_cli a", content: "#cli" };
		return(false);
	});
	
	$("#nav_functions").click(function () {
		if(currTab.content == "#functions")
			return;
		$(currTab.button).removeClass("selected");
		$("#nav_functions a").addClass("selected");
		$(currTab.content).fadeOut("50", function() { $("#functions").fadeIn("250"); });
		currTab = { button: "#nav_functions a", content: "#functions" };
		return(false);
	});

	$("#nav_settings").click(function () {
		if(currTab.content == "#settings")
			return;
		$(currTab.button).removeClass("selected");
		$("#nav_settings a").addClass("selected");
		$(currTab.content).fadeOut("50", function() { $("#settings").fadeIn("250"); });
		currTab = { button: "#nav_settings a", content: "#settings" };
		return(false);
	});
	
	$(".container").corner();
	
	var date = new Date();
	date.setDate(date.getDate() + 3650);
	$.cookies.setOptions({expiresAt: date});
	
	var date = new Date();
	var curr_date = date.getDate();
	var curr_month = date.getMonth();
	var curr_year = date.getFullYear();
	curr_month++;
				   
	$("#fnc_resume_date").DatePicker({ 		
		format:'m/d/y',
		date: curr_month + "/" + curr_date + "/" + curr_year,
		current: curr_month + "/" + curr_date + "/" + curr_year,
		starts: 1,
		position: 'bottom',
		onBeforeShow: function(){
			if($("#fnc_resume_date").val().length) {
				$("#fnc_resume_date").DatePickerSetDate($("#fnc_resume_date").val(), true);
			}
		},
		onChange: function(formated, dates){
			$("#fnc_resume_date").val(formated);
			$("#fnc_resume_date").DatePickerHide();
		}
 	});
 	
	$("#fnc_revoke_date").DatePicker({ 		
		format:'m/d/y',
		date: curr_month + "/" + curr_date + "/" + curr_year,
		current: curr_month + "/" + curr_date + "/" + curr_year,
		starts: 1,
		position: 'bottom',
		onBeforeShow: function(){
			if($("#fnc_revoke_date").val().length) {
				$("#fnc_revoke_date").DatePickerSetDate($("#fnc_revoke_date").val(), true);
			}
		},
		onChange: function(formated, dates){
			$("#fnc_revoke_date").val(formated);
			$("#fnc_revoke_date").DatePickerHide();
		}
 	});	
 		
	$("#fnc_connect_resdate").DatePicker({ 		
		format:'m/d/y',
		date: curr_month + "/" + curr_date + "/" + curr_year,
		current: curr_month + "/" + curr_date + "/" + curr_year,
		starts: 1,
		position: 'bottom',
		onBeforeShow: function(){
			if($("#fnc_connect_resdate").val().length) {
				$("#fnc_connect_resdate").DatePickerSetDate($("#fnc_connect_resdate").val(), true);
			}
		},
		onChange: function(formated, dates){
			$("#fnc_connect_resdate").val(formated);
			$("#fnc_connect_resdate").DatePickerHide();
		}
 	});	

	$("#fnc_connect_revdate").DatePicker({ 		
		format:'m/d/y',
		date: curr_month + "/" + curr_date + "/" + curr_year,
		current: curr_month + "/" + curr_date + "/" + curr_year,
		starts: 1,
		position: 'bottom',
		onBeforeShow: function(){
			if($("#fnc_connect_revdate").val().length) {
				$("#fnc_connect_revdate").DatePickerSetDate($("#fnc_connect_revdate").val(), true);
			}
		},
		onChange: function(formated, dates){
			$("#fnc_connect_revdate").val(formated);
			$("#fnc_connect_revdate").DatePickerHide();
		}
 	});	

	$("#targets .edit a").click(editTarget);
	$("#targets .del a").click(deleteTarget);
	
	$("#frm_cli").submit(function() {
		var tid = $("#cli_target").attr("value").substr(3);
		
		if(!tid.length) {
			alert("Please add a target by accessing the settings tab!");
			return(false);
		}
				
		$("#cli_host").val($.cookies.get("target["+tid+"][host]"));
		$("#cli_port").val($.cookies.get("target["+tid+"][port]"));
		$("#cli_user").val($.cookies.get("target["+tid+"][user]"));
		$("#cli_secret").val($.cookies.get("target["+tid+"][secret]"));
	});
	
	$("#frm_fnc").submit(function() {
		var tid = $("#fnc_target").attr("value").substr(3);
		
		if(!tid.length) {
			alert("Please add a target by accessing the settings tab!");
			return(false);
		}
				
		$("#fnc_host").val($.cookies.get("target["+tid+"][host]"));
		$("#fnc_port").val($.cookies.get("target["+tid+"][port]"));
		$("#fnc_user").val($.cookies.get("target["+tid+"][user]"));
		$("#fnc_secret").val($.cookies.get("target["+tid+"][secret]"));
		
		$('#fnc_response').val("Processing...");
		
		$(this).ajaxSubmit({
			type: 'post',
			dataType: 'json',
			success: function(data, responseCode) {
		    	$('#fnc_response').val(data.text);
			}
		});		
		
		return(false);
	});	
	
	$("#frm_settings").submit(function() {
		saveTarget();
		return(false);
	});
	
	if($("ul:last","#targets").length) {
		$("#tid").val($("ul:last","#targets").attr("id").substr(3)-0+1);
	} else {
		$("#tid").val(1);
	}
});

var editTarget = function() {
	var target = $(this).parent().parent();
	var tid = $(target).attr("id").substr(3);
	
	$("#tid").val(tid);
	$("#host").val($.cookies.get("target["+tid+"][host]"));
	$("#port").val($.cookies.get("target["+tid+"][port]"));
	$("#user").val($.cookies.get("target["+tid+"][user]"));
	$("#secret").val($.cookies.get("target["+tid+"][secret]"));
		
	return(false);
};

var deleteTarget = function() {
	var target = $(this).parent().parent();
	var tid = $(target).attr("id").substr(3);
	
	var answer = confirm("Delete "+$(".target",target).text()+"?");
	if(answer == true) {
		$.cookies.del("target["+tid+"][host]");
		$.cookies.del("target["+tid+"][port]");
		$.cookies.del("target["+tid+"][user]");
		$.cookies.del("target["+tid+"][secret]");	
	  	$(target).fadeOut("250", function() { $(target).remove(); });
		$("#cli_target option[value=tgt"+tid+"]").remove();
		$("#fnc_target option[value=tgt"+tid+"]").remove();
	}
   	return(false);
};

var saveTarget = function() {
	if($("#host").val().length == 0) {
		alert("Please enter a target host!");
		return;
	}
	
	if($("#port").val().length == 0) {
		alert("Please enter a target port!");
		return;
	}
	
	if($("#user").val().length == 0) {
		alert("Please enter a username!");
		return;
	}

	if($("#secret").val().length == 0) {
		alert("Please enter a password!");
		return;
	}	

	var tid = $("#tid").val();
	
	if($("#tgt"+tid,"#targets").length) {
		var update = $("#user").val()+"@"+$("#host").val()+":"+$("#port").val();
		$("#cli_target option[value=tgt"+tid+"]").text(update);
		$("#fnc_target option[value=tgt"+tid+"]").text(update);
		$(".target","#tgt"+tid,"#targets").text(update);
	} else {
		var target = "<ul id=\"tgt"+tid+"\">"
					   + "<li class=\"target\">"+$("#user").val()+"@"+$("#host").val()+":"+$("#port").val()+"</li>"
					   + "<li class=\"edit\"><a href=\"#\"><a href=\"#\">Edit</a></li>"
					   + "<li class=\"del\"><a href=\"#\"><a href=\"#\">Delete</a></li>"
				   + "</ul>";

		$("#cli_target").append("<option value=\"tgt"+tid+"\">"+$("#user").val()+"@"+$("#host").val()+":"+$("#port").val()+"</option>");
		$("#fnc_target").append("<option value=\"tgt"+tid+"\">"+$("#user").val()+"@"+$("#host").val()+":"+$("#port").val()+"</option>");
			
		$("#targets").append(target);

		$("#targets .edit a").unbind();
		$("#targets .del a").unbind();
		
		$("#targets .edit a").click(editTarget);
		$("#targets .del a").click(deleteTarget);
	}
	
	$.cookies.set("target["+tid+"][host]", $("#host").val());
	$.cookies.set("target["+tid+"][port]", $("#port").val());
	$.cookies.set("target["+tid+"][user]", $("#user").val());
	$.cookies.set("target["+tid+"][secret]", $("#secret").val());
	
	$("#tid").val($("ul:last","#targets").attr("id").substr(3)-0+1);
	
	$("#host").val("");
	$("#port").val("");
	$("#user").val("");
	$("#secret").val("");
}